package com.isu.gaswellwatch.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.isu.gaswellwatch.entity.Device;
import com.isu.gaswellwatch.entity.DeviceOptLog;
import com.isu.gaswellwatch.vo.DeviceHistoryVO;
import com.isu.gaswellwatch.vo.DeviceVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

@Mapper
@Repository
public interface DeviceDao extends BaseMapper<Device> {

    Page<DeviceVO> page(Page<Object> page,
                        @Param("gasWellName") String gasWellName,
                        @Param("gasStationName") String gasStationName,
                        @Param("deviceTypeId") Long deviceTypeId,
                        @Param("blockId") Long blockId);


    DeviceVO getDeviceById(@Param("id") Long id);

    Page<DeviceHistoryVO> historyPage(Page<Object> objectPage,
                                      @Param("startTime")Date startTime,
                                      @Param("endTime")Date endTime,
                                      @Param("deviceId") Long deviceId,
                                      @Param("tableName") String tableName,
                                      @Param("deviceProduct") String deviceProduct);

    Page<DeviceOptLog> deviceOptLogPage(Page<DeviceOptLog> objectPage,
                                        @Param("startTime")Date startTime,
                                        @Param("endTime")Date endTime,
                                        @Param("deviceId") Long deviceId);

    List<DeviceVO> getDeviceVOByIds(@Param("idList")List<Long> deviceIdList);

    List<DeviceHistoryVO> getPressureChartData(Long deviceId, String startTime, String endTime, String tableName);

    List<DeviceHistoryVO> getSwitchStatusData(Long deviceId, String startTime, String endTime, String tableName,String deviceProduct);
}

