package com.isu.gaswellwatch.dto.modbus;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.SuperBuilder;
import org.apache.commons.lang3.StringUtils;


@Getter
@Setter
@SuperBuilder
@NoArgsConstructor
public class ModbusCommandDto extends CommandTypeComparable implements CommandDto {
    /**
     * 12位十六进制的命令
     */
    private String command;

    /**
     * 采集长度
     */
    private int length;

    /**
     * 自定义标识
     * 采集情况下会推送到MQ的内容格式为：自定义标识+设备反馈报文
     */
    private String key;

    /**
     * 网关唯一标识符
     */
    private String identifier;

    public String getCommand() {
        return StringUtils.isBlank(this.command) ? this.command : this.command.toUpperCase();
    }
}
