package com.isu.gaswellwatch.vo.command.scss;

import com.isu.gaswellwatch.dto.modbus.ModbusCommandDto;
import com.isu.gaswellwatch.vo.command.Command;
import com.isu.gaswellwatch.vo.command.Timing;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.SuperBuilder;

import java.io.Serial;
import java.math.BigDecimal;
import java.util.Collection;

/**
 * 套压模式
 *
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/12/10 17:01
 */
@Getter
@Setter
@SuperBuilder
public class CasingMode extends Command implements Timing {
    @Serial
    private static final long serialVersionUID = -6609483152571838191L;
    /**
     * 开井套压
     */
    @NotNull(message = "开井套压不能为空")
    private BigDecimal wellOpenPressureValue = BigDecimal.ZERO;
    /**
     * 关井套压
     */
    @NotNull(message = "关井套压不能为空")
    private BigDecimal wellClosePressureValue = BigDecimal.ZERO;
    /**
     * 最小关井时间
     */
    @NotBlank(message = "最小关井时间不能为空，格式：HH:mm:ss")
    private String minWellCloseTimeDuration;
    /**
     * 最大关井时间
     */
    @NotBlank(message = "最大关井时间不能为空，格式：HH:mm:ss")
    private String maxWellCloseTimeDuration;

    public CasingMode() {
        this.setCode("SCSS.CASING_MODE");
    }


    @Override
    protected Collection<ModbusCommandDto> builderModbusCommand() {
        return null;
    }
}